var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};

// src/mod.ts
var mod_exports = {};
__export(mod_exports, {
  DefaultSceneConfig: () => DefaultSceneConfig,
  Scene: () => Scene,
  Scroller: () => Scroller
});
module.exports = __toCommonJS(mod_exports);

// src/deferred.ts
function deferred() {
  let methods;
  let state = "pending";
  const promise = new Promise((resolve, reject) => {
    methods = {
      async resolve(value) {
        await value;
        state = "fulfilled";
        resolve(value);
      },
      reject(reason) {
        state = "rejected";
        reject(reason);
      }
    };
  });
  Object.defineProperty(promise, "state", { get: () => state });
  return Object.assign(promise, methods);
}

// src/queue.ts
var _list, _limit, _top, _bottom, _move, move_fn;
var Queue = class {
  constructor(limit = 1024) {
    __privateAdd(this, _move);
    __privateAdd(this, _list, void 0);
    __privateAdd(this, _limit, void 0);
    __privateAdd(this, _top, 0);
    __privateAdd(this, _bottom, 0);
    __privateSet(this, _limit, limit);
    __privateSet(this, _list, new Array(limit + 100));
    __privateGet(this, _list)[0] = deferred();
  }
  async *[Symbol.asyncIterator]() {
    for (; ; ) {
      yield this.pop();
    }
  }
  pop() {
    const dataDeferred = __privateGet(this, _list)[__privateGet(this, _top)];
    __privateSet(this, _top, __privateMethod(this, _move, move_fn).call(this, __privateGet(this, _top)));
    return dataDeferred;
  }
  push(data) {
    __privateGet(this, _list)[__privateGet(this, _bottom)].resolve(data);
    __privateSet(this, _bottom, __privateMethod(this, _move, move_fn).call(this, __privateGet(this, _bottom)));
    __privateGet(this, _list)[__privateGet(this, _bottom)] = deferred();
  }
};
_list = new WeakMap();
_limit = new WeakMap();
_top = new WeakMap();
_bottom = new WeakMap();
_move = new WeakSet();
move_fn = function(n) {
  return n === __privateGet(this, _limit) ? 0 : n + 1;
};

// src/utils.ts
var p2nMap = /* @__PURE__ */ new Map();
function p2n(p) {
  let n = p2nMap.get(p);
  if (!n) {
    n = Number(p.slice(0, p.length - 1)) / 100;
    p2nMap.set(p, n);
  }
  return n;
}

// src/scene.ts
var DefaultSceneConfig = {
  play: "100%",
  duration: "100%"
};
var _scroller, _el, _events, _prevState, _state, _cfg, _rect, _duration, _playStart, _stateChanged, stateChanged_get, _isEnter, isEnter_get, _isLeave, isLeave_get, _preUpdate, preUpdate_fn, _trigger, trigger_fn;
var Scene = class {
  constructor(scroller, el, cfg) {
    __privateAdd(this, _stateChanged);
    __privateAdd(this, _isEnter);
    __privateAdd(this, _isLeave);
    __privateAdd(this, _preUpdate);
    __privateAdd(this, _trigger);
    __privateAdd(this, _scroller, void 0);
    __privateAdd(this, _el, void 0);
    __privateAdd(this, _events, new Queue());
    __privateAdd(this, _prevState, void 0);
    __privateAdd(this, _state, void 0);
    __privateAdd(this, _cfg, void 0);
    __privateAdd(this, _rect, void 0);
    __privateAdd(this, _duration, void 0);
    __privateAdd(this, _playStart, void 0);
    __privateSet(this, _scroller, scroller);
    __privateSet(this, _el, el);
    __privateSet(this, _cfg, cfg);
  }
  get emitter() {
    return __privateGet(this, _events);
  }
  update() {
    __privateMethod(this, _preUpdate, preUpdate_fn).call(this);
    const event = {
      target: __privateGet(this, _el),
      progress: (__privateGet(this, _playStart) - __privateGet(this, _rect).top) / __privateGet(this, _duration)
    };
    __privateMethod(this, _trigger, trigger_fn).call(this, "update", event);
    if (__privateGet(this, _isEnter, isEnter_get)) {
      __privateMethod(this, _trigger, trigger_fn).call(this, "enter", event);
    } else if (__privateGet(this, _isLeave, isLeave_get)) {
      __privateMethod(this, _trigger, trigger_fn).call(this, "leave", event);
    }
  }
};
_scroller = new WeakMap();
_el = new WeakMap();
_events = new WeakMap();
_prevState = new WeakMap();
_state = new WeakMap();
_cfg = new WeakMap();
_rect = new WeakMap();
_duration = new WeakMap();
_playStart = new WeakMap();
_stateChanged = new WeakSet();
stateChanged_get = function() {
  return __privateGet(this, _prevState) !== __privateGet(this, _state);
};
_isEnter = new WeakSet();
isEnter_get = function() {
  if (__privateGet(this, _stateChanged, stateChanged_get)) {
    const direction = __privateGet(this, _scroller).direction;
    return direction === "forward" && __privateGet(this, _prevState) === "before" || direction === "reverse" && __privateGet(this, _prevState) === "after";
  }
  return false;
};
_isLeave = new WeakSet();
isLeave_get = function() {
  return __privateGet(this, _stateChanged, stateChanged_get) && __privateGet(this, _prevState) === "during";
};
_preUpdate = new WeakSet();
preUpdate_fn = function() {
  const clientHeight = __privateGet(this, _scroller).clientHeight;
  const rect = __privateSet(this, _rect, __privateGet(this, _el).getBoundingClientRect());
  const { top, bottom } = rect;
  let playStart = __privateGet(this, _cfg).play;
  if (typeof playStart === "string") {
    playStart = clientHeight * p2n(playStart);
  }
  __privateSet(this, _playStart, playStart);
  let duration = __privateGet(this, _cfg).duration;
  if (typeof duration === "string") {
    duration = (bottom - top) * p2n(duration);
  }
  __privateSet(this, _duration, duration);
  __privateSet(this, _prevState, __privateGet(this, _state));
  const newState = top <= playStart && top + duration >= playStart ? "during" : top < playStart ? "after" : "before";
  if (!__privateGet(this, _state)) {
    __privateSet(this, _prevState, newState);
  }
  __privateSet(this, _state, newState);
};
_trigger = new WeakSet();
trigger_fn = function(type, event) {
  __privateGet(this, _events).push([type, event]);
};

// src/scroller.ts
var doc = window.document;
var _el2, _scenes, _prevScollY, _update, update_fn;
var Scroller = class {
  constructor(el) {
    __privateAdd(this, _update);
    __privateAdd(this, _el2, void 0);
    __privateAdd(this, _scenes, /* @__PURE__ */ new Map());
    __privateAdd(this, _prevScollY, void 0);
    __privateSet(this, _el2, el);
    const update = () => {
      __privateMethod(this, _update, update_fn).call(this);
    };
    doc.addEventListener("scroll", update);
    this.destory = () => {
      doc.removeEventListener("scroll", update);
    };
  }
  get clientHeight() {
    return window.innerHeight || doc.documentElement.clientHeight;
  }
  addScene(el, cfg) {
    const scene = new Scene(this, el, cfg);
    __privateGet(this, _scenes).set(el, scene);
    return scene;
  }
  addSceneWithDefault(el) {
    return this.addScene(el, DefaultSceneConfig);
  }
};
_el2 = new WeakMap();
_scenes = new WeakMap();
_prevScollY = new WeakMap();
_update = new WeakSet();
update_fn = function() {
  var _a;
  __privateSet(this, _prevScollY, this.scrollY);
  this.scrollY = typeof ((_a = __privateGet(this, _el2)) == null ? void 0 : _a.scrollTop) === "number" ? __privateGet(this, _el2).scrollTop : window.scrollY;
  if (!__privateGet(this, _prevScollY)) {
    __privateSet(this, _prevScollY, this.scrollY);
  }
  const delta = this.scrollY - __privateGet(this, _prevScollY);
  this.direction = delta > 0 ? "forward" : delta < 0 ? "reverse" : "paused";
  for (const [, scene] of __privateGet(this, _scenes)) {
    scene.update();
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DefaultSceneConfig,
  Scene,
  Scroller
});
